local text = Text2D(getCurrentScene():getObjectByName("text"))
-- GLOBAL VARIABLES
-- tracking statuts: if 1 : tracking, if 0 : no tracking
gtrackingStatus = 0
-- get the keyframe index from a tracked object with auto-initialization
gtrackingKeyFrameIndex = -1

-- scene
local scene = getCurrentScene()
-- get the virtual camera, will be used to send to the MLT
local camera = Camera(scene:getCurrentCamera())
-- get the videocapture, will be used to send to the MLT
local videoCapture_live = VideoCapture(scene:getObjectByName("videocapture_live"))

-- Tracking
local MLTPlugin = getMLTPluginManager()
-- Error status
local errorStatus = eOk
-- tracking index : the index of the tracker.xml (because we can open more than 1 tracking.xml file).
local trackingIndex = -1
-- the fps of the Tracking engine
local trackingRate = 0
-- vector to put the tracking position
local trackingPosition = Vector3()
-- quaternion to put the tracking orientation
local trackingOrientation = Quaternion()
-- 3D object receiving tracking pose
local trackingObject = Object3D(scene:getObjectByName("Tracking_Object"))
-- object index from the tracking scenario (0 : first object, 1 : second object...) (this is the index in the "Objects" panel of the CV GUI)
local trackingObjectIndex = 0

-- this is how to start a tracking. the function needs the path to the tracker.xml file, the videocapture id and the camera object.
errorStatus, trackingIndex = MLTPlugin:startTracking("tracker.xml", videoCapture_live:getVidCapID(), camera)



local componentInterface = getComponentInterface()
--timer = Timer()

oneTime_fin = false
oneTime_pause = false
oneTime_start = false

prev_time = 0
--play_type = "pause"
--play_type = "play"
play_on = false
tracking_on = false
tracking_off = false

miku = Scenette(scene:getObjectByName("xx"))
anim = miku:getAnimation(0)
anim:setLoop(false)
anim:setSpeed(1.187)

orient_x = 270
miku_scale = 1.2

myType = "balsa"

--anim:play()

if errorStatus == eOk then
	repeat
	
		isCommand, command = componentInterface:pullCommand()
	    if isCommand == true then
	        if command["CommandName"] == "com" then
	            if command["arg0"] == "play" then
	            --LOG("PLAYSTART")
	                anim:play()
	                play_on = true
	                tracking_on = false
	            end
	            
	            if command["arg0"] == "pause" then
	                anim:pause()
	            end
	        end
	    end
		
		--miku:setPosition(0,position_y,-50)
		miku:setScale(miku_scale)
		miku:setOrientationEuler(orient_x,0,0,camera)
		
		
		
		
		errorStatus, gtrackingStatus = MLTPlugin:getTargetStatus(trackingIndex, trackingObjectIndex)
		
		errorStatus, gtrackingKeyFrameIndex = MLTPlugin:getRecognizedKeyFrameIndex(trackingIndex, trackingObjectIndex)
		
		-- if our object is detected...
		if (gtrackingStatus == 1) then
			
			if gtrackingKeyFrameIndex == 0 then
				--miku image
				
				if myType == "balsa" then
					--change scenario
					componentInterface:executeAppFunc("sendstat","changetomiku")
				end
				
			elseif gtrackingKeyFrameIndex == 1 then
				--gamba image
				LOG("G")
				if myType == "balsa" then
					--change scenario
					componentInterface:executeAppFunc("sendstat","changetogamba")
				end
			
				
			elseif gtrackingKeyFrameIndex == 2 then
				--balsa image
				
				anim:play()
			
				tracking_on = true
				play_on = true
				oneTime_pause = false
				
				if oneTime_start == false then
					if tracking_off == false then
						componentInterface:executeAppFunc("sendstat","start")
					else
						componentInterface:executeAppFunc("sendstat","restart")
					end
					
					oneTime_start = true
				end
				
				
			end
			
			componentInterface:executeAppFunc("sendstat","playon")
			
			--...we can get the position and set it to the "father" object
	        MLTPlugin:getTargetPos(trackingIndex, trackingObjectIndex, trackingPosition, trackingOrientation)
			trackingObject:setPosition(trackingPosition, camera)
	        trackingObject:setOrientation(trackingOrientation, camera)
			-- we change the visibility of the main "father" object
			
		
		-- if the tracking is lost
		else
			-- we change the visibility of the main "father" object
			if tracking_on == true then
				--PX^[gƂꍇ
				tracking_off = true
				
				oneTime_start = false
				anim:pause()
				if oneTime_pause == false then
					componentInterface:executeAppFunc("sendstat","pause")
					oneTime_pause = true
				end
			end
			
			componentInterface:executeAppFunc("sendstat","playoff")
	    end
		
		
		
		
		
		--c_time = timer:getTime()
		
		a_time = anim:getTimePosition()
		f_time = math.floor(a_time)
		if f_time ~= prev_time then
			--text:setText(f_time)
			componentInterface:executeAppFunc("sendstat","time",f_time)
		end
		prev_time = f_time
		
		
		
		if a_time > 248 and oneTime_fin == false then
			oneTime_fin = true
			componentInterface:executeAppFunc("sendstat","fin")
			--LOG("aa sindo")
		end
		
		
		if play_on == true and anim:hasEnded() then
			componentInterface:executeAppFunc("sendstat","end")
			play_on = false
			tracking_on = false
			tracking_off = false
			prev_time = 0
			oneTime_fin = false
			anim:stop()
		end
		
		
		
		
	until coroutine.yield()
end